## org.opencyc.elf.goal
Class Goal

    java.lang.Object
      |
      +--org.opencyc.elf.ELFObject
            |
            +--org.opencyc.elf.goal.Goal

public class Goal
extends ELFObject

Provides the Goal container for the Elementary Loop Functioning (ELF). Either a goal state or a goal procedure is specified.

Author:
  Stephen L. Reed

  Copyright 2001 Cycorp, Inc., license is open source GNU LGPL.

  the license

  www.opencyc.org

  OpenCyc at SourceForge

  THIS SOFTWARE AND KNOWLEDGE BASE CONTENT ARE PROVIDED ``AS IS'' AND ANY EXPRESSED OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE OPENCYC ORGANIZATION OR ITS CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE AND KNOWLEDGE BASE CONTENT, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

Field Summary
`protected CycFort` `context` the context of the goal
`protected java.lang.String` `goalComment` the goal stated in natural language
`protected java.util.ArrayList` `goalFailureStates` the list of states which if entered, indicate goal failure
`protected org.opencyc.uml.core.Procedure` `goalProcedure` the goal procedure, which is mutually exclusive with the goal state
`protected CycAssertion` `goalSentence` the goal sentence stated in CycL
`protected State` `goalState` the goal state, which is mutally exclusive with the goal procedure
`protected Importance` `importance` the goal importance
`protected Goal` `parent` the parent goal of this goal
`protected java.util.ArrayList` `subGoals` the subgoals of this goal

Fields inherited from class org.opencyc.elf.ELFObject
`name`

Constructor Summary
`Goal()` Constructs a new Goal object.

Method Summary
`CycFort` `getContext()` Gets the context of the goal
`java.lang.String` `getGoalComment()` Gets the goal stated in natural language
`java.util.ArrayList` `getGoalFailureStates()` Gets the list of states which if entered, indicate goal failure
`org.opencyc.uml.core.Procedure` `getGoalProcedure()` Gets the goal procedure
`CycAssertion` `getGoalSentence()` Gets the goal sentence stated in CycL
`State` `getGoalState()` Gets the goal state
`Importance` `getImportance()` Gets the goal importance
`Goal` `getParent()` Gets the parent goal of this goal
`java.util.ArrayList` `getSubGoals()` Gets the subgoals of this goal
`void` `setContext(CycFort context)` Sets the context of the goal
`void` `setGoalComment(java.lang.String goalComment)` Sets the goal stated in natural language
`void` `setGoalFailureStates(java.util.ArrayList goalFailureStates)` Sets the list of states which if entered, indicate goal failure
`void` `setGoalProcedure(org.opencyc.uml.core.Procedure goalProcedure)` Sets the goal procedure
`void` `setGoalSentence(CycAssertion goalSentence)` Sets the goal sentence stated in CycL
`void` `setGoalState(State goalState)` Sets the goal state
`void` `setImportance(Importance importance)` Sets the goal importance
`void` `setParent(Goal parent)` Sets the parent goal of this goal
`void` `setSubGoals(java.util.ArrayList subGoals)` Sets the subgoals of this goal

Methods inherited from class org.opencyc.elf.ELFObject
`getName, setName, toString`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

Field Detail

### goalState

    protected State goalState

  the goal state, which is mutally exclusive with the goal procedure

### goalProcedure

    protected org.opencyc.uml.core.Procedure goalProcedure

  the goal procedure, which is mutually exclusive with the goal state

### goalSentence

    protected CycAssertion goalSentence

  the goal sentence stated in CycL

### goalComment

    protected java.lang.String goalComment

  the goal stated in natural language

### goalFailureStates

    protected java.util.ArrayList goalFailureStates

  the list of states which if entered, indicate goal failure

### parent

    protected Goal parent

  the parent goal of this goal

### subGoals

    protected java.util.ArrayList subGoals

  the subgoals of this goal

### importance

    protected Importance importance

  the goal importance

### context

    protected CycFort context

  the context of the goal

Constructor Detail

### Goal

    public Goal()

  Constructs a new Goal object.

Method Detail

### getGoalState

    public State getGoalState()

  Gets the goal state
  Returns:
    the goal state

### setGoalState

    public void setGoalState(State goalState)

  Sets the goal state
  Parameters:
    `goalState` - the goal state

### getGoalProcedure

    public org.opencyc.uml.core.Procedure getGoalProcedure()

  Gets the goal procedure
  Returns:
    the goal procedure

### setGoalProcedure

    public void setGoalProcedure(org.opencyc.uml.core.Procedure goalProcedure)

  Sets the goal procedure
  Parameters:
    `goalProcedure` - the goal procedure

### getGoalSentence

    public CycAssertion getGoalSentence()

  Gets the goal sentence stated in CycL
  Returns:
    the goal sentence stated in CycL

### setGoalSentence

    public void setGoalSentence(CycAssertion goalSentence)

  Sets the goal sentence stated in CycL
  Parameters:
    `goalSentence` - the goal sentence stated in CycL

### getGoalComment

    public java.lang.String getGoalComment()

  Gets the goal stated in natural language
  Returns:
    the goal stated in natural language

### setGoalComment

    public void setGoalComment(java.lang.String goalComment)

  Sets the goal stated in natural language
  Parameters:
    `goalComment` - the goal stated in natural language

### getGoalFailureStates

    public java.util.ArrayList getGoalFailureStates()

  Gets the list of states which if entered, indicate goal failure
  Returns:
    the list of states which if entered, indicate goal failure

### setGoalFailureStates

    public void setGoalFailureStates(java.util.ArrayList goalFailureStates)

  Sets the list of states which if entered, indicate goal failure
  Parameters:
    `goalFailureStates` - the list of states which if entered, indicate goal failure

### getParent

    public Goal getParent()

  Gets the parent goal of this goal
  Returns:
    the parent goal of this goal

### setParent

    public void setParent(Goal parent)

  Sets the parent goal of this goal
  Parameters:
    `parent` - the parent goal of this goal

### getSubGoals

    public java.util.ArrayList getSubGoals()

  Gets the subgoals of this goal
  Returns:
    the subgoals of this goal

### setSubGoals

    public void setSubGoals(java.util.ArrayList subGoals)

  Sets the subgoals of this goal
  Parameters:
    `subGoals` - the subgoals of this goal

### getImportance

    public Importance getImportance()

  Gets the goal importance
  Returns:
    the goal importance

### setImportance

    public void setImportance(Importance importance)

  Sets the goal importance
  Parameters:
    `importance` - the goal importance

### getContext

    public CycFort getContext()

  Gets the context of the goal
  Returns:
    the context of the goal

### setContext

    public void setContext(CycFort context)

  Sets the context of the goal
  Parameters:
    `context` - the context of the goal